<?php

class ACMS_POST_Unit_Update extends ACMS_POST_Unit
{
    function post()
    {
        $bid    = $this->Post->get('bid');
        $eid    = $this->Post->get('eid');

        if ( !$eid ) die();
        if ( !IS_LICENSED ) die();
        if ( !sessionWithCompilation() ) {
            if ( !sessionWithContribution() ) die();
            if ( SUID <> ACMS_RAM::entryUser($eid) ) die();
        }

        $Column = ACMS_POST_Entry::extractColumn();
        $Res    = ACMS_POST_Entry::saveColumn($Column, $eid, $bid, true);
        $primaryImageId_p   = $this->Post->get('primary_image');
        $primaryImageId     = empty($Res) ? null : (
            !UTID ? reset($Res) : (
                !empty($Res[UTID]) ? $Res[UTID] : reset($Res)
            )
        );

        if ( intval($primaryImageId) > 0 && intval($primaryImageId_p) === intval($primaryImageId) ) {
            $DB     = DB::singleton(dsn());
            $SQL    = SQL::newUpdate('entry');
            $SQL->addUpdate('entry_primary_image', $primaryImageId);
            $SQL->addWhereOpr('entry_id', EID);
            $SQL->addWhereOpr('entry_blog_id', BID);
            $DB->query($SQL->get(dsn()), 'exec');
        }

        $this->saveFulltext('eid', $eid, $this->loadEntryFulltext($eid));
        $this->fixEntry($eid);

        return $this->Post;
    }
}
